/* smvr.h 3/14/1999, Oguz Yetkin (oguz@writeme.com)
   Simple Minded Virtual Reality (SMVR)
*/

#ifndef SMVR_H
#define SMVR_H 1

#define MAX 20

#include<sys/time.h>

struct _object{
  int list_id;	     /*opengl list id*/
  float x,y,z,r,g,b; /*location & color */
  float sx,sy,sz;    /*scale*/
  float ro,theta,phi; /* rotation angles, not yet implemented */
  char name[MAX];    /*object name*/
  char filename[MAX];
  int display;	     /*render?*/
  int rendered;	     /* has the object been placed inside a list? */
  int grabbed;
  int tocopy;	     /* should we copy this object? */
  float radius;	     /* for compatibility, probably not needed */
  int fChanged;      /* true if the object has changed since last poll - KLC */
  
  /* physics info added 6/28/1999 by OY */
  float mass;
  float volume;
  float vx;
  float vy;
  float vz;
  float dt;	/* time elapsed since last check by physics system */
  /*  struct timeval ptime;*/	/* previous time the object was traversed */

  struct _object* next; 
  
};

/* find on name */
struct _object* smvrfind(struct _object** objList, char* str); 

#endif
  	
