/* tokenize.c 3/20/1999 Oguz Yetkin
   function to take a string and turn it into
   something that looks like argv.  Returns number
   of tokens.  
*/

#include<stdio.h>
#include<string.h>
#include "tokenize.h"

#define MAX_BUF 50 

#define DEBUG 0

/* tokenize, messy function to make an argv-like array out
   of a string
   use:
   pass in: char* input	 (your string)
            char*** tokens  (address of char** tokens in calling func)

*/

int tokenize(char*** tokens, char* input){
 int count=0;	/* count of tokens	*/
 int ptr=0;	/* pointer within string */
 int bptr=0;	/* pointer within buffer */ 
 char  buf[20];
 int dummy;
 char ch='x';
 int i;


/* count tokens without wasting too much time */
 for(i=0;ch!='\0';i++){
    ch=input[i]; 
    if(ch==' '){
     count++;
    }
 }
 if(i!=1){
   count++;	
 }
 
 if(DEBUG)
  printf("\ncounted: %d tokens",count);
 
 (*tokens)=(char**)malloc(count*sizeof(char*));
 for(i=0;i<count;i++){
  (*tokens)[i]=(char*)malloc(sizeof(buf));
 }
  
 count=0;
 ch='x';
 ptr=0;
 bptr=0;

 while(ch!='\0'){
  ch=input[ptr];
  if(ch=='\0' && ptr==0){	  /* empty string */
   return 0;
  }
  if(ch!=' '&& ch!='\0'){ 
   if(ch!='\n'){
    buf[bptr]=ch;
    bptr++;
   }
    ptr++;
  }else{ /* we've come to a new token */
   buf[bptr]='\0';
   if(DEBUG) 
    printf("\nThe %dth buffer is %s",count, buf);
   ptr++;
   bptr++;
   strcpy((*tokens)[count],buf);
   
   count++;
   bptr=0;
  } 
 } 
 return count;
}

void free2(char** tokens, int size){ /* utility to free 2-d array */
 int i;
 for(i=0;i<size;i++){ /* be safe consumers of memory */
   free(tokens[i]);
 }
 free(tokens);
}


/* stub for debugging and demonstration 

int main(int argc, char** argv){
 int count;
 char** tokens;
 int i=0;

 if(argc==1){
  printf("\nneed argument!\n");
  return 1;
 }
 
 count=tokenize(&tokens, argv[1]); 
        
 printf("\ntokenized %s, there are %d tokens\n",argv[1],count);
 for(i=0;i<count;i++){
  printf("tokens[%d]=%s\n",i,tokens[i]);
 }

 free2(tokens, count); 

 return 0;

}

*/
